diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/wifi-phy-ofdma-test.cc ns-3.45/src/wifi/test/wifi-phy-ofdma-test.cc
--- ns-3.44/src/wifi/test/wifi-phy-ofdma-test.cc	2025-03-09 16:55:49.811372800 -0700
+++ ns-3.45/src/wifi/test/wifi-phy-ofdma-test.cc	2025-06-01 20:34:45.641702400 -0700
@@ -1105,73 +1326,99 @@
     // both PHYs should be back to CCA_BUSY (due to the interference) at the same time,
     // even the PHY that has no PSDU addressed to it.
     Simulator::Schedule(Seconds(5) + m_expectedPpduDuration - NanoSeconds(1),
-                        &TestDlOfdmaPhyTransmission::CheckPhyState,
+                        &TestDlOfdmaPhyTransmission<LatestPhyEntityType>::CheckPhyState,
                         this,
                         m_phySta1,
                         WifiPhyState::RX);
     Simulator::Schedule(Seconds(5) + m_expectedPpduDuration - NanoSeconds(1),
-                        &TestDlOfdmaPhyTransmission::CheckPhyState,
+                        &TestDlOfdmaPhyTransmission<LatestPhyEntityType>::CheckPhyState,
                         this,
                         m_phySta2,
                         WifiPhyState::RX);
     Simulator::Schedule(Seconds(5) + m_expectedPpduDuration - NanoSeconds(1),
-                        &TestDlOfdmaPhyTransmission::CheckPhyState,
+                        &TestDlOfdmaPhyTransmission<LatestPhyEntityType>::CheckPhyState,
                         this,
                         m_phySta3,
                         WifiPhyState::CCA_BUSY);
     Simulator::Schedule(Seconds(5) + m_expectedPpduDuration,
-                        &TestDlOfdmaPhyTransmission::CheckPhyState,
+                        &TestDlOfdmaPhyTransmission<LatestPhyEntityType>::CheckPhyState,
                         this,
                         m_phySta1,
                         WifiPhyState::CCA_BUSY);
     Simulator::Schedule(Seconds(5) + m_expectedPpduDuration,
-                        &TestDlOfdmaPhyTransmission::CheckPhyState,
+                        &TestDlOfdmaPhyTransmission<LatestPhyEntityType>::CheckPhyState,
                         this,
                         m_phySta2,
                         WifiPhyState::CCA_BUSY);
     Simulator::Schedule(Seconds(5) + m_expectedPpduDuration,
-                        &TestDlOfdmaPhyTransmission::CheckPhyState,
+                        &TestDlOfdmaPhyTransmission<LatestPhyEntityType>::CheckPhyState,
                         this,
                         m_phySta3,
                         WifiPhyState::CCA_BUSY);
 
-    // One PSDU of 1000 bytes should have been unsuccessfuly received by STA 1 (since interference
+    // One PSDU of 1000 bytes should have been unsuccessfully received by STA 1 (since interference
     // occupies RU 1)
-    Simulator::Schedule(Seconds(5.1), &TestDlOfdmaPhyTransmission::CheckResultsSta1, this, 0, 1, 0);
-    // One PSDU of 1500 bytes should have been unsuccessfuly received by STA 2 (since interference
+    Simulator::Schedule(Seconds(5.1),
+                        &TestDlOfdmaPhyTransmission<LatestPhyEntityType>::CheckResultsSta1,
+                        this,
+                        0,
+                        1,
+                        0);
+    // One PSDU of 1500 bytes should have been unsuccessfully received by STA 2 (since interference
     // occupies RU 2)
-    Simulator::Schedule(Seconds(5.1), &TestDlOfdmaPhyTransmission::CheckResultsSta2, this, 0, 1, 0);
+    Simulator::Schedule(Seconds(5.1),
+                        &TestDlOfdmaPhyTransmission<LatestPhyEntityType>::CheckResultsSta2,
+                        this,
+                        0,
+                        1,
+                        0);
     // No PSDU should have been received by STA3
-    Simulator::Schedule(Seconds(5.1), &TestDlOfdmaPhyTransmission::CheckResultsSta3, this, 0, 0, 0);
+    Simulator::Schedule(Seconds(5.1),
+                        &TestDlOfdmaPhyTransmission<LatestPhyEntityType>::CheckResultsSta3,
+                        this,
+                        0,
+                        0,
+                        0);
 
-    Simulator::Schedule(Seconds(5.5), &TestDlOfdmaPhyTransmission::ResetResults, this);
+    Simulator::Schedule(Seconds(5.5),
+                        &TestDlOfdmaPhyTransmission<LatestPhyEntityType>::ResetResults,
+                        this);
 
     Simulator::Run();
 }
 
+template <typename LatestPhyEntityType>
 void
-TestDlOfdmaPhyTransmission::DoRun()
+TestDlOfdmaPhyTransmission<LatestPhyEntityType>::DoRun()
 {
-    m_frequency = MHz_u{5180};
+    m_frequency = MHz_u{5955};
     m_channelWidth = MHz_u{20};
     m_expectedPpduDuration = NanoSeconds(306400);
     RunOne();
 
-    m_frequency = MHz_u{5190};
+    m_frequency = MHz_u{5965};
     m_channelWidth = MHz_u{40};
     m_expectedPpduDuration = NanoSeconds(156800);
     RunOne();
 
-    m_frequency = MHz_u{5210};
+    m_frequency = MHz_u{5985};
     m_channelWidth = MHz_u{80};
     m_expectedPpduDuration = NanoSeconds(102400);
     RunOne();
 
-    m_frequency = MHz_u{5250};
+    m_frequency = MHz_u{6025};
     m_channelWidth = MHz_u{160};
     m_expectedPpduDuration = NanoSeconds(75200);
     RunOne();
 
+    if (m_modClass >= WIFI_MOD_CLASS_EHT)
+    {
+        m_frequency = MHz_u{6105};
+        m_channelWidth = MHz_u{320};
+        m_expectedPpduDuration = NanoSeconds(61600);
+        RunOne();
+    }
+
     Simulator::Destroy();
 }
 
@@ -1285,14 +1532,14 @@
      * @param phy the PHY
      * @param expectedState the expected state of the PHY
      */
-    void CheckPhyState(Ptr<OfdmaSpectrumWifiPhy> phy, WifiPhyState expectedState);
+    void CheckPhyState(Ptr<OfdmaSpectrumWifiPhy<HePhy>> phy, WifiPhyState expectedState);
 
     /**
      * Check the PHY state now
      * @param phy the PHY
      * @param expectedState the expected state of the PHY
      */
-    void DoCheckPhyState(Ptr<OfdmaSpectrumWifiPhy> phy, WifiPhyState expectedState);
+    void DoCheckPhyState(Ptr<OfdmaSpectrumWifiPhy<HePhy>> phy, WifiPhyState expectedState);
 
     uint32_t m_countRxSuccessSta1; ///< count RX success for STA 1
     uint32_t m_countRxSuccessSta2; ///< count RX success for STA 2
@@ -1301,10 +1548,10 @@
     uint32_t m_countRxBytesSta1;   ///< count RX bytes for STA 1
     uint32_t m_countRxBytesSta2;   ///< count RX bytes for STA 2
 
-    Ptr<SpectrumWifiPhy> m_phyAp;           ///< PHY of AP
-    Ptr<OfdmaSpectrumWifiPhy> m_phySta1;    ///< PHY of STA 1
-    Ptr<OfdmaSpectrumWifiPhy> m_phySta2;    ///< PHY of STA 2
-    Ptr<WaveformGenerator> m_phyInterferer; ///< PHY of interferer
+    Ptr<SpectrumWifiPhy> m_phyAp;               ///< PHY of AP
+    Ptr<OfdmaSpectrumWifiPhy<HePhy>> m_phySta1; ///< PHY of STA 1
+    Ptr<OfdmaSpectrumWifiPhy<HePhy>> m_phySta2; ///< PHY of STA 2
+    Ptr<WaveformGenerator> m_phyInterferer;     ///< PHY of interferer
 
     MHz_u m_frequency;    ///< frequency
     MHz_u m_channelWidth; ///< channel width
@@ -1361,20 +1608,19 @@
                           false,
                           false};
 
-    HeRu::RuType ruType =
-        puncturedSubchannels.empty()
-            ? HeRu::RU_484_TONE
-            : (puncturedSubchannels.at(1) ? HeRu::RU_242_TONE : HeRu::RU_484_TONE);
+    RuType ruType = puncturedSubchannels.empty()
+                        ? RuType::RU_484_TONE
+                        : (puncturedSubchannels.at(1) ? RuType::RU_242_TONE : RuType::RU_484_TONE);
     HeRu::RuSpec ru1(ruType, 1, true);
     txVector.SetRu(ru1, rxStaId1);
     txVector.SetMode(HePhy::GetHeMcs7(), rxStaId1);
     txVector.SetNss(1, rxStaId1);
 
     ruType = puncturedSubchannels.empty()
-                 ? HeRu::RU_484_TONE
-                 : (puncturedSubchannels.at(1) ? HeRu::RU_484_TONE : HeRu::RU_242_TONE);
+                 ? RuType::RU_484_TONE
+                 : (puncturedSubchannels.at(1) ? RuType::RU_484_TONE : RuType::RU_242_TONE);
     HeRu::RuSpec ru2(ruType,
-                     ruType == HeRu::RU_484_TONE ? 2 : (puncturedSubchannels.at(3) ? 3 : 4),
+                     ruType == RuType::RU_484_TONE ? 2 : (puncturedSubchannels.at(3) ? 3 : 4),
                      true);
     txVector.SetRu(ru2, rxStaId2);
     txVector.SetMode(HePhy::GetHeMcs9(), rxStaId2);
@@ -1383,14 +1629,17 @@
     RuAllocation ruAlloc;
     if (puncturedSubchannels.empty())
     {
-        std::fill_n(std::back_inserter(ruAlloc), 4, 200);
+        ruAlloc.push_back(200);
+        ruAlloc.push_back(114);
+        ruAlloc.push_back(114);
+        ruAlloc.push_back(200);
     }
     else
     {
         ruAlloc.push_back(puncturedSubchannels.at(1) ? 192 : 200);
-        ruAlloc.push_back(puncturedSubchannels.at(1) ? 113 : 200);
+        ruAlloc.push_back(puncturedSubchannels.at(1) ? 113 : 114);
         ruAlloc.push_back(puncturedSubchannels.at(2) ? 113
-                                                     : (puncturedSubchannels.at(3) ? 192 : 200));
+                                                     : (puncturedSubchannels.at(3) ? 192 : 114));
         ruAlloc.push_back(puncturedSubchannels.at(2) ? 192
                                                      : (puncturedSubchannels.at(3) ? 113 : 200));
     }
@@ -1487,7 +1736,7 @@
                           "The number of successfully received packets by STA 1 is not correct!");
     NS_TEST_ASSERT_MSG_EQ(m_countRxFailureSta1,
                           expectedRxFailure,
-                          "The number of unsuccessfuly received packets by STA 1 is not correct!");
+                          "The number of unsuccessfully received packets by STA 1 is not correct!");
     NS_TEST_ASSERT_MSG_EQ(m_countRxBytesSta1,
                           expectedRxBytes,
                           "The number of bytes received by STA 1 is not correct!");
@@ -1503,14 +1752,15 @@
                           "The number of successfully received packets by STA 2 is not correct!");
     NS_TEST_ASSERT_MSG_EQ(m_countRxFailureSta2,
                           expectedRxFailure,
-                          "The number of unsuccessfuly received packets by STA 2 is not correct!");
+                          "The number of unsuccessfully received packets by STA 2 is not correct!");
     NS_TEST_ASSERT_MSG_EQ(m_countRxBytesSta2,
                           expectedRxBytes,
                           "The number of bytes received by STA 2 is not correct!");
 }
 
 void
-TestDlOfdmaPhyPuncturing::CheckPhyState(Ptr<OfdmaSpectrumWifiPhy> phy, WifiPhyState expectedState)
+TestDlOfdmaPhyPuncturing::CheckPhyState(Ptr<OfdmaSpectrumWifiPhy<HePhy>> phy,
+                                        WifiPhyState expectedState)
 {
     // This is needed to make sure PHY state will be checked as the last event if a state change
     // occurred at the exact same time as the check
@@ -1518,7 +1768,8 @@
 }
 
 void
-TestDlOfdmaPhyPuncturing::DoCheckPhyState(Ptr<OfdmaSpectrumWifiPhy> phy, WifiPhyState expectedState)
+TestDlOfdmaPhyPuncturing::DoCheckPhyState(Ptr<OfdmaSpectrumWifiPhy<HePhy>> phy,
+                                          WifiPhyState expectedState)
 {
     WifiPhyState currentState;
     PointerValue ptr;
@@ -1558,10 +1809,11 @@
     apDev->SetPhy(m_phyAp);
     apNode->AggregateObject(apMobility);
     apNode->AddDevice(apDev);
+    apDev->SetStandard(WIFI_STANDARD_80211ax);
 
     Ptr<Node> sta1Node = CreateObject<Node>();
     Ptr<WifiNetDevice> sta1Dev = CreateObject<WifiNetDevice>();
-    m_phySta1 = CreateObject<OfdmaSpectrumWifiPhy>(1);
+    m_phySta1 = CreateObject<OfdmaSpectrumWifiPhy<HePhy>>(1);
     Ptr<InterferenceHelper> sta1InterferenceHelper = CreateObject<InterferenceHelper>();
     m_phySta1->SetInterferenceHelper(sta1InterferenceHelper);
     Ptr<ErrorRateModel> sta1ErrorModel = CreateObject<NistErrorRateModel>();
@@ -1577,10 +1829,11 @@
     sta1Dev->SetPhy(m_phySta1);
     sta1Node->AggregateObject(sta1Mobility);
     sta1Node->AddDevice(sta1Dev);
+    sta1Dev->SetStandard(WIFI_STANDARD_80211ax);
 
     Ptr<Node> sta2Node = CreateObject<Node>();
     Ptr<WifiNetDevice> sta2Dev = CreateObject<WifiNetDevice>();
-    m_phySta2 = CreateObject<OfdmaSpectrumWifiPhy>(2);
+    m_phySta2 = CreateObject<OfdmaSpectrumWifiPhy<HePhy>>(2);
     Ptr<InterferenceHelper> sta2InterferenceHelper = CreateObject<InterferenceHelper>();
     m_phySta2->SetInterferenceHelper(sta2InterferenceHelper);
     Ptr<ErrorRateModel> sta2ErrorModel = CreateObject<NistErrorRateModel>();
@@ -1596,6 +1849,7 @@
     sta2Dev->SetPhy(m_phySta2);
     sta2Node->AggregateObject(sta2Mobility);
     sta2Node->AddDevice(sta2Dev);
+    sta2Dev->SetStandard(WIFI_STANDARD_80211ax);
 
     Ptr<Node> interfererNode = CreateObject<Node>();
     Ptr<NonCommunicatingNetDevice> interfererDev = CreateObject<NonCommunicatingNetDevice>();
@@ -1699,7 +1953,7 @@
 
     if (m_indexSubchannel < 2) // interference in RU 1
     {
-        // One PSDU of 1000 bytes should have been unsuccessfuly received by STA 1
+        // One PSDU of 1000 bytes should have been unsuccessfully received by STA 1
         Simulator::Schedule(Seconds(1.1),
                             &TestDlOfdmaPhyPuncturing::CheckResultsSta1,
                             this,
@@ -1723,7 +1977,7 @@
                             1,
                             0,
                             1000);
-        // One PSDU of 1500 bytes should have been unsuccessfuly received by STA 2
+        // One PSDU of 1500 bytes should have been unsuccessfully received by STA 2
         Simulator::Schedule(Seconds(1.1),
                             &TestDlOfdmaPhyPuncturing::CheckResultsSta2,
                             this,
@@ -1871,9 +2125,9 @@
      */
     void CheckUid(uint16_t staId, uint64_t expectedUid);
 
-    Ptr<OfdmaSpectrumWifiPhy> m_phyAp;   ///< PHY of AP
-    Ptr<OfdmaSpectrumWifiPhy> m_phySta1; ///< PHY of STA 1
-    Ptr<OfdmaSpectrumWifiPhy> m_phySta2; ///< PHY of STA 2
+    Ptr<OfdmaSpectrumWifiPhy<HePhy>> m_phyAp;   ///< PHY of AP
+    Ptr<OfdmaSpectrumWifiPhy<HePhy>> m_phySta1; ///< PHY of STA 1
+    Ptr<OfdmaSpectrumWifiPhy<HePhy>> m_phySta2; ///< PHY of STA 2
 
     uint64_t m_ppduUidAp;   ///< UID of PPDU transmitted by AP
     uint64_t m_ppduUidSta1; ///< UID of PPDU transmitted by STA1
@@ -1905,7 +2159,7 @@
 
     Ptr<Node> apNode = CreateObject<Node>();
     Ptr<WifiNetDevice> apDev = CreateObject<WifiNetDevice>();
-    m_phyAp = CreateObject<OfdmaSpectrumWifiPhy>(0);
+    m_phyAp = CreateObject<OfdmaSpectrumWifiPhy<HePhy>>(0);
     Ptr<InterferenceHelper> apInterferenceHelper = CreateObject<InterferenceHelper>();
     m_phyAp->SetInterferenceHelper(apInterferenceHelper);
     Ptr<ErrorRateModel> apErrorModel = CreateObject<NistErrorRateModel>();
@@ -1933,7 +2187,7 @@
 
     Ptr<Node> sta1Node = CreateObject<Node>();
     Ptr<WifiNetDevice> sta1Dev = CreateObject<WifiNetDevice>();
-    m_phySta1 = CreateObject<OfdmaSpectrumWifiPhy>(1);
+    m_phySta1 = CreateObject<OfdmaSpectrumWifiPhy<HePhy>>(1);
     Ptr<InterferenceHelper> sta1InterferenceHelper = CreateObject<InterferenceHelper>();
     m_phySta1->SetInterferenceHelper(sta1InterferenceHelper);
     Ptr<ErrorRateModel> sta1ErrorModel = CreateObject<NistErrorRateModel>();
@@ -1953,7 +2207,7 @@
 
     Ptr<Node> sta2Node = CreateObject<Node>();
     Ptr<WifiNetDevice> sta2Dev = CreateObject<WifiNetDevice>();
-    m_phySta2 = CreateObject<OfdmaSpectrumWifiPhy>(2);
+    m_phySta2 = CreateObject<OfdmaSpectrumWifiPhy<HePhy>>(2);
     Ptr<InterferenceHelper> sta2InterferenceHelper = CreateObject<InterferenceHelper>();
     m_phySta2->SetInterferenceHelper(sta2InterferenceHelper);
     Ptr<ErrorRateModel> sta2ErrorModel = CreateObject<NistErrorRateModel>();
@@ -2055,13 +2309,13 @@
                           false};
 
     uint16_t rxStaId1 = 1;
-    HeRu::RuSpec ru1(HeRu::RU_106_TONE, 1, true);
+    HeRu::RuSpec ru1(RuType::RU_106_TONE, 1, true);
     txVector.SetRu(ru1, rxStaId1);
     txVector.SetMode(HePhy::GetHeMcs7(), rxStaId1);
     txVector.SetNss(1, rxStaId1);
 
     uint16_t rxStaId2 = 2;
-    HeRu::RuSpec ru2(HeRu::RU_106_TONE, 2, true);
+    HeRu::RuSpec ru2(RuType::RU_106_TONE, 2, true);
     txVector.SetRu(ru2, rxStaId2);
     txVector.SetMode(HePhy::GetHeMcs9(), rxStaId2);
     txVector.SetNss(1, rxStaId2);
@@ -2109,7 +2363,7 @@
     WifiTxVector trigVector{txVector2};
 
     uint16_t rxStaId1 = 1;
-    HeRu::RuSpec ru1(HeRu::RU_106_TONE, 1, false);
+    HeRu::RuSpec ru1(RuType::RU_106_TONE, 1, false);
     txVector1.SetRu(ru1, rxStaId1);
     txVector1.SetMode(HePhy::GetHeMcs7(), rxStaId1);
     txVector1.SetNss(1, rxStaId1);
@@ -2127,7 +2381,7 @@
     psdus1.insert(std::make_pair(rxStaId1, psdu1));
 
     uint16_t rxStaId2 = 2;
-    HeRu::RuSpec ru2(HeRu::RU_106_TONE, 2, false);
+    HeRu::RuSpec ru2(RuType::RU_106_TONE, 2, false);
     txVector2.SetRu(ru2, rxStaId2);
     txVector2.SetMode(HePhy::GetHeMcs9(), rxStaId2);
     txVector2.SetNss(1, rxStaId2);
@@ -2144,14 +2398,16 @@
     auto psdu2 = Create<WifiPsdu>(pkt2, hdr2);
     psdus2.insert(std::make_pair(rxStaId2, psdu2));
 
-    const auto txDuration1 = OfdmaSpectrumWifiPhy::CalculateTxDuration(psdu1->GetSize(),
-                                                                       txVector1,
-                                                                       m_phySta1->GetPhyBand(),
-                                                                       rxStaId1);
-    const auto txDuration2 = OfdmaSpectrumWifiPhy::CalculateTxDuration(psdu2->GetSize(),
-                                                                       txVector2,
-                                                                       m_phySta1->GetPhyBand(),
-                                                                       rxStaId2);
+    const auto txDuration1 =
+        OfdmaSpectrumWifiPhy<HePhy>::CalculateTxDuration(psdu1->GetSize(),
+                                                         txVector1,
+                                                         m_phySta1->GetPhyBand(),
+                                                         rxStaId1);
+    const auto txDuration2 =
+        OfdmaSpectrumWifiPhy<HePhy>::CalculateTxDuration(psdu2->GetSize(),
+                                                         txVector2,
+                                                         m_phySta1->GetPhyBand(),
+                                                         rxStaId2);
     const auto txDuration = std::max(txDuration1, txDuration2);
 
     txVector1.SetLength(
@@ -2161,8 +2417,8 @@
         HePhy::ConvertHeTbPpduDurationToLSigLength(txDuration, txVector2, m_phySta2->GetPhyBand())
             .first);
 
-    auto hePhyAp = DynamicCast<HePhy>(m_phyAp->GetPhyEntity(WIFI_MOD_CLASS_HE));
-    hePhyAp->SetTrigVector(trigVector, txDuration);
+    auto phyAp = m_phyAp->GetPhyEntity();
+    phyAp->SetTrigVector(trigVector, txDuration);
 
     m_phySta1->Send(psdus1, txVector1);
     m_phySta2->Send(psdus2, txVector2);
@@ -2316,7 +2572,7 @@
      */
     void CheckBytesDropped(size_t expectedBytesDropped);
 
-    Ptr<OfdmaSpectrumWifiPhy> m_phy; ///< Phy
+    Ptr<OfdmaSpectrumWifiPhy<HePhy>> m_phy; ///< Phy
 
     uint64_t m_totalBytesDropped; ///< total number of dropped bytes
     WifiTxVector m_trigVector;    ///< TRIGVECTOR
@@ -2401,7 +2657,7 @@
                           false,
                           false};
 
-    HeRu::RuSpec ru(HeRu::RU_106_TONE, staId, false);
+    HeRu::RuSpec ru(RuType::RU_106_TONE, staId, false);
     txVector.SetRu(ru, staId);
     txVector.SetMode(HePhy::GetHeMcs7(), staId);
     txVector.SetNss(1, staId);
@@ -2417,10 +2673,10 @@
     auto psdu = Create<WifiPsdu>(pkt, hdr);
     psdus.insert(std::make_pair(staId, psdu));
 
-    auto ppduDuration = OfdmaSpectrumWifiPhy::CalculateTxDuration(psdu->GetSize(),
-                                                                  txVector,
-                                                                  m_phy->GetPhyBand(),
-                                                                  staId);
+    auto ppduDuration = OfdmaSpectrumWifiPhy<HePhy>::CalculateTxDuration(psdu->GetSize(),
+                                                                         txVector,
+                                                                         m_phy->GetPhyBand(),
+                                                                         staId);
     auto ppdu = Create<HePpdu>(psdus,
                                txVector,
                                m_phy->GetOperatingChannel(),
@@ -2429,11 +2685,11 @@
                                HePpdu::PSD_NON_HE_PORTION);
 
     // Send non-OFDMA part
-    const auto nonOfdmaDuration = m_phy->GetHePhy()->CalculateNonHeDurationForHeTb(txVector);
+    const auto nonOfdmaDuration = m_phy->GetPhyEntity()->CalculateNonHeDurationForHeTb(txVector);
     const auto centerFrequency =
-        m_phy->GetHePhy()->GetCenterFrequenciesForNonHePart(ppdu, staId).front();
-    MHz_u ruWidth = HeRu::GetBandwidth(txVector.GetRu(staId).GetRuType());
-    MHz_u channelWidth = ruWidth < MHz_u{20} ? MHz_u{20} : ruWidth;
+        m_phy->GetPhyEntity()->GetCenterFrequenciesForNonHePart(ppdu, staId).front();
+    auto ruWidth = WifiRu::GetBandwidth(WifiRu::GetRuType(txVector.GetRu(staId)));
+    auto channelWidth = ruWidth < MHz_u{20} ? MHz_u{20} : ruWidth;
     Ptr<SpectrumValue> rxPsd = WifiSpectrumValueHelper::CreateHeOfdmTxPowerSpectralDensity(
         centerFrequency,
         channelWidth,
@@ -2458,7 +2714,7 @@
     // Schedule OFDMA part
     auto ppduOfdma = DynamicCast<HePpdu>(ppdu->Copy()); // since flag will be modified
     ppduOfdma->SetTxPsdFlag(HePpdu::PSD_HE_PORTION);
-    const auto band = m_phy->GetHePhy()->GetRuBandForRx(txVector, staId);
+    const auto band = m_phy->GetPhyEntity()->GetRuBandForRx(txVector, staId);
     auto rxPsdOfdma =
         WifiSpectrumValueHelper::CreateHeMuOfdmTxPowerSpectralDensity({DEFAULT_FREQUENCY},
                                                                       DEFAULT_CHANNEL_WIDTH,
@@ -2498,7 +2754,7 @@
     Ptr<Node> node = CreateObject<Node>();
     Ptr<WifiNetDevice> dev = CreateObject<WifiNetDevice>();
     dev->SetStandard(WIFI_STANDARD_80211ax);
-    m_phy = CreateObject<OfdmaSpectrumWifiPhy>(0);
+    m_phy = CreateObject<OfdmaSpectrumWifiPhy<HePhy>>(0);
     Ptr<InterferenceHelper> interferenceHelper = CreateObject<InterferenceHelper>();
     Ptr<ErrorRateModel> error = CreateObject<NistErrorRateModel>();
     auto mac = CreateObjectWithAttributes<ApWifiMac>(
@@ -2823,9 +3079,9 @@
         m_lastRxSuccess = true;
     }
 
-    void NotifyRxEndError() override
+    void NotifyRxEndError(const WifiTxVector& txVector) override
     {
-        NS_LOG_FUNCTION(this);
+        NS_LOG_FUNCTION(this << txVector);
         m_lastRxEnd = Simulator::Now();
         ++m_notifyRxEnd;
         m_lastRxSuccess = false;
@@ -2934,6 +3190,7 @@
  *
  * @brief UL-OFDMA PHY test
  */
+template <typename LatestPhyEntityType>
 class TestUlOfdmaPhyTransmission : public TestCase
 {
   public:
@@ -2949,7 +3206,6 @@
     };
 
     TestUlOfdmaPhyTransmission();
-    ~TestUlOfdmaPhyTransmission() override;
 
   private:
     void DoSetup() override;
@@ -2957,15 +3213,13 @@
     void DoRun() override;
 
     /**
-     * Get TXVECTOR for HE TB PPDU.
+     * Get TXVECTOR for HE PPDU.
      * @param txStaId the ID of the TX STA
      * @param index the RU index used for the transmission
      * @param bssColor the BSS color of the TX STA
      * @return the TXVECTOR for HE TB PPDU
      */
-    WifiTxVector GetTxVectorForHeTbPpdu(uint16_t txStaId,
-                                        std::size_t index,
-                                        uint8_t bssColor) const;
+    WifiTxVector GetTxVectorForTbPpdu(uint16_t txStaId, std::size_t index, uint8_t bssColor) const;
     /**
      * Set TRIGVECTOR for HE TB PPDU
      *
@@ -2982,12 +3236,12 @@
      * @param bssColor the BSS color of the TX STA
      * @param incrementUid whether UID shall be incremented
      */
-    void SendHeTbPpdu(uint16_t txStaId,
-                      std::size_t index,
-                      std::size_t payloadSize,
-                      uint64_t uid,
-                      uint8_t bssColor,
-                      bool incrementUid);
+    void SendTbPpdu(uint16_t txStaId,
+                    std::size_t index,
+                    std::size_t payloadSize,
+                    uint64_t uid,
+                    uint8_t bssColor,
+                    bool incrementUid);
 
     /**
      * Send HE SU PPDU function
@@ -2996,7 +3250,7 @@
      * @param uid the UID of the trigger frame that is initiating this transmission
      * @param bssColor the BSS color of the TX STA
      */
-    void SendHeSuPpdu(uint16_t txStaId, std::size_t payloadSize, uint64_t uid, uint8_t bssColor);
+    void SendSuPpdu(uint16_t txStaId, std::size_t payloadSize, uint64_t uid, uint8_t bssColor);
 
     /**
      * Set the BSS color
@@ -3054,7 +3308,7 @@
      * @param band the indices of the band over which the power is measured
      * @param expectedRxPower the expected received power
      */
-    void CheckNonOfdmaRxPower(Ptr<OfdmaSpectrumWifiPhy> phy,
+    void CheckNonOfdmaRxPower(Ptr<OfdmaSpectrumWifiPhy<LatestPhyEntityType>> phy,
                               WifiSpectrumBandInfo band,
                               Watt_u expectedRxPower);
     /**
@@ -3063,7 +3317,7 @@
      * @param band the indices of the band over which the power is measured
      * @param expectedRxPower the expected received power
      */
-    void CheckOfdmaRxPower(Ptr<OfdmaSpectrumWifiPhy> phy,
+    void CheckOfdmaRxPower(Ptr<OfdmaSpectrumWifiPhy<LatestPhyEntityType>> phy,
                            WifiSpectrumBandInfo band,
                            Watt_u expectedRxPower);
 
@@ -3077,9 +3331,11 @@
      * @param phy the PHY
      * @param expectedState the expected state of the PHY
      */
-    void CheckPhyState(Ptr<OfdmaSpectrumWifiPhy> phy, WifiPhyState expectedState);
+    void CheckPhyState(Ptr<OfdmaSpectrumWifiPhy<LatestPhyEntityType>> phy,
+                       WifiPhyState expectedState);
     /// @copydoc CheckPhyState
-    void DoCheckPhyState(Ptr<OfdmaSpectrumWifiPhy> phy, WifiPhyState expectedState);
+    void DoCheckPhyState(Ptr<OfdmaSpectrumWifiPhy<LatestPhyEntityType>> phy,
+                         WifiPhyState expectedState);
 
     /**
      * Check the the number of RX start notifications at the AP as well as the last time a RX start
@@ -3177,63 +3433,66 @@
      */
     void LogScenario(std::string log) const;
 
-    Ptr<OfdmaSpectrumWifiPhy> m_phyAp;   ///< PHY of AP
-    Ptr<OfdmaSpectrumWifiPhy> m_phySta1; ///< PHY of STA 1
-    Ptr<OfdmaSpectrumWifiPhy> m_phySta2; ///< PHY of STA 2
-    Ptr<OfdmaSpectrumWifiPhy> m_phySta3; ///< PHY of STA 3
+    WifiModulationClass m_modClass; ///< the modulation class to consider for the test
+
+    Ptr<OfdmaSpectrumWifiPhy<LatestPhyEntityType>> m_phyAp;   ///< PHY of AP
+    Ptr<OfdmaSpectrumWifiPhy<LatestPhyEntityType>> m_phySta1; ///< PHY of STA 1
+    Ptr<OfdmaSpectrumWifiPhy<LatestPhyEntityType>> m_phySta2; ///< PHY of STA 2
+    Ptr<OfdmaSpectrumWifiPhy<LatestPhyEntityType>> m_phySta3; ///< PHY of STA 3
 
     std::shared_ptr<OfdmaTestPhyListener>
         m_apPhyStateListener; ///< listener for AP PHY state transitions
 
     Ptr<WaveformGenerator> m_phyInterferer; ///< PHY of interferer
 
-    uint32_t m_countRxSuccessFromSta1; ///< count RX success from STA 1
-    uint32_t m_countRxSuccessFromSta2; ///< count RX success from STA 2
-    uint32_t m_countRxFailureFromSta1; ///< count RX failure from STA 1
-    uint32_t m_countRxFailureFromSta2; ///< count RX failure from STA 2
-    uint32_t m_countRxBytesFromSta1;   ///< count RX bytes from STA 1
-    uint32_t m_countRxBytesFromSta2;   ///< count RX bytes from STA 2
-
-    MHz_u m_frequency;           ///< frequency
-    MHz_u m_channelWidth;        ///< channel width
-    Time m_expectedPpduDuration; ///< expected duration to send MU PPDU
+    uint32_t m_countRxSuccessFromSta1{0}; ///< count RX success from STA 1
+    uint32_t m_countRxSuccessFromSta2{0}; ///< count RX success from STA 2
+    uint32_t m_countRxFailureFromSta1{0}; ///< count RX failure from STA 1
+    uint32_t m_countRxFailureFromSta2{0}; ///< count RX failure from STA 2
+    uint32_t m_countRxBytesFromSta1{0};   ///< count RX bytes from STA 1
+    uint32_t m_countRxBytesFromSta2{0};   ///< count RX bytes from STA 2
+
+    MHz_u m_frequency{DEFAULT_FREQUENCY};        ///< frequency
+    MHz_u m_channelWidth{DEFAULT_CHANNEL_WIDTH}; ///< channel width
+    Time m_expectedPpduDuration;                 ///< expected duration to send MU PPDU
 };
 
-TestUlOfdmaPhyTransmission::TestUlOfdmaPhyTransmission()
-    : TestCase("UL-OFDMA PHY test"),
-      m_countRxSuccessFromSta1(0),
-      m_countRxSuccessFromSta2(0),
-      m_countRxFailureFromSta1(0),
-      m_countRxFailureFromSta2(0),
-      m_countRxBytesFromSta1(0),
-      m_countRxBytesFromSta2(0),
-      m_frequency(DEFAULT_FREQUENCY),
-      m_channelWidth(DEFAULT_CHANNEL_WIDTH),
-      m_expectedPpduDuration(NanoSeconds(271200))
+template <typename LatestPhyEntityType>
+TestUlOfdmaPhyTransmission<LatestPhyEntityType>::TestUlOfdmaPhyTransmission()
+    : TestCase{std::string("UL-OFDMA PHY test for ") +
+               ((Demangle(typeid(LatestPhyEntityType).name()).find("He") != std::string::npos)
+                    ? "HE"
+                    : "EHT")},
+      m_modClass{(Demangle(typeid(LatestPhyEntityType).name()).find("He") != std::string::npos)
+                     ? WIFI_MOD_CLASS_HE
+                     : WIFI_MOD_CLASS_EHT},
+      m_expectedPpduDuration{NanoSeconds(271200)}
 {
 }
 
-void
-TestUlOfdmaPhyTransmission::SendHeSuPpdu(uint16_t txStaId,
-                                         std::size_t payloadSize,
-                                         uint64_t uid,
-                                         uint8_t bssColor)
+template <typename LatestPhyEntityType>
+void
+TestUlOfdmaPhyTransmission<LatestPhyEntityType>::SendSuPpdu(uint16_t txStaId,
+                                                            std::size_t payloadSize,
+                                                            uint64_t uid,
+                                                            uint8_t bssColor)
 {
     NS_LOG_FUNCTION(this << txStaId << payloadSize << uid << +bssColor);
     WifiConstPsduMap psdus;
 
-    WifiTxVector txVector{HePhy::GetHeMcs7(),
-                          0,
-                          WIFI_PREAMBLE_HE_SU,
-                          NanoSeconds(800),
-                          1,
-                          1,
-                          0,
-                          m_channelWidth,
-                          false,
-                          false,
-                          false,
-                          bssColor};
+    WifiTxVector txVector{
+        (m_modClass == WIFI_MOD_CLASS_HE) ? HePhy::GetHeMcs7() : EhtPhy::GetEhtMcs7(),
+        0,
+        (m_modClass == WIFI_MOD_CLASS_HE) ? WIFI_PREAMBLE_HE_SU : WIFI_PREAMBLE_EHT_MU,
+        NanoSeconds(800),
+        1,
+        1,
+        0,
+        m_channelWidth,
+        false,
+        false,
+        false,
+        bssColor};
 
     auto pkt = Create<Packet>(payloadSize);
     WifiMacHeader hdr;
@@ -3247,7 +3506,7 @@
     auto psdu = Create<WifiPsdu>(pkt, hdr);
     psdus.insert(std::make_pair(SU_STA_ID, psdu));
 
-    Ptr<OfdmaSpectrumWifiPhy> phy;
+    Ptr<OfdmaSpectrumWifiPhy<LatestPhyEntityType>> phy;
     if (txStaId == 1)
     {
         phy = m_phySta1;
